HDU 2473Junk-Mail Filter 【并查集,删点】

Junk-Mail Filter

Time Limit: 15000/8000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 7018    Accepted Submission(s): 2240


Problem Description
Recognizing junk mails is a tough task. The method used here consists of two steps:
1) Extract the common characteristics from the incoming email.
2) Use a filter matching the set of common characteristics extracted to determine whether the email is a spam.

We want to extract the set of common characteristics from the N sample junk emails available at the moment, and thus having a handy data-analyzing tool would be helpful. The tool should support the following kinds of operations:

a) “M X Y”, meaning that we think that the characteristics of spam X and Y are the same. Note that the relationship defined here is transitive, so
relationships (other than the one between X and Y) need to be created if they are not present at the moment.

b) “S X”, meaning that we think spam X had been misidentified. Your tool should remove all relationships that spam X has when this command is received; after that, spam X will become an isolated node in the relationship graph.

Initially no relationships exist between any pair of the junk emails, so the number of distinct characteristics at that time is N.
Please help us keep track of any necessary information to solve our problem.
 

Input
There are multiple test cases in the input file.
Each test case starts with two integers, N and M (1 ≤ N ≤ 10 5 , 1 ≤ M ≤ 10 6), the number of email samples and the number of operations. M lines follow, each line is one of the two formats described above.
Two successive test cases are separated by a blank line. A case with N = 0 and M = 0 indicates the end of the input file, and should not be processed by your program.
 

Output
For each test case, please print a single integer, the number of distinct common characteristics, to the console. Follow the format as indicated in the sample below.
 

Sample Input
  
  
5 6 M 0 1 M 1 2 M 1 3 S 1 M 1 2 S 3 3 1 M 1 2 0 0
 

Sample Output
  
  
Case #1: 3 Case #2: 2
 

题意:一些点M a,b代表a,b是一个集合,S a代表从集合中删除a点,最后输出有几类

思路:并查集,M代表合并,S代表删除,下面讲一下删除操作

大家都知道合并操作就是找到找到两个节点的父亲,修改父亲,如果删除就是将该点的父亲重新设置成自己,这样行不行呢?

这是不行的,比如1,2,3的父亲都是1,现在删除1,1的父亲还是1,2,3也是1,集合还是1个,正确的应该是2个。

那删除节点的父亲不设成自己给新申请一个节点当做父亲,比如1,2,3的父亲都是1,在一个集合,现在删除1,申请了4当做1的父亲,2,3父亲都是1,然后Find(2)找2的父亲

2的父亲是1,但是1的父亲是4,所以给2的父亲更新成了4,3同理,所以还不行。

正确的方法是每一个点都设立一个虚拟父亲比如1,2,3的父亲分别是4,5,6,现在合并1,2,3都在一个集合,那他们的父亲都是4,现在删除1,那就给1重新申请一个节点7

现在2,3的父亲是4,1的父亲是7,删除成功。



#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

int per[2200000];
int vis[2200000];
int n, m, id;
char str[5];

int find(int x){
	if(x == per[x])
		return x;
	else return per[x] = find(per[x]);
}

void jion(int x, int y){
	int fx = find(x);
	int fy = find(y);
	if(fx != fy)
		per[fy] = fx;
}

void del (int x){
	per[x] = id ++;
}

int main (){
	int a,b,c;
	int k = 1;
	while(scanf("%d%d", &n, &m), n || m){
		id = n + n; 
		for(int i = 0; i < n; ++i)
			per[i] = i + n;//虚拟父节点 
		for(int i = n; i <= n + n + m; ++i)//n+n+m: 最多可能删除m个节点
			per[i] = i;
			
			while(m--){ 
			scanf("%s", &str);
			if(str[0] == 'M'){
				scanf("%d%d", &a, &b);
				 jion(a,b);
			}
			else{
				scanf("%d", &c);
				del(c);
			}
		} 
		int ans = 0;
		memset(vis, 0 ,sizeof(vis));
		for(int i = 0; i < n; ++i){
			int x = find(i);
			if(!vis[x]){
				ans++;
				vis[x] = 1;
			} 
		}
		printf("Case #%d: %d\n", k++, ans);
	}
	return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值